<?php
/**
* Amiro_SAPE_client class
*
* The class contains set of methods that provide support sape functionality by Amiro CMS
*
* <pre>
* HISTORY:
*
* version 1.2
*     1.  The class is created
* </pre>
*
* @author Alexey  Karzhenkov <alexey@amiro.ru>
* @version 1.0. Last changes: 11/01/2008 by Alexey Karzhenkov
* @copyright Amiro.CMS. All rights reserved. Changes are not allowed.
* @package core
*/

class Amiro_SAPE_client extends SAPE_client {
    public $_amiro_links_db_file; // FROM_VAR

    function Amiro_SAPE_client($path, $options = null) {
        $this->_amiro_links_db_file = $path;
        parent::SAPE_client($options);
    }

    function load_links($dirname = "") {
        parent::load_links($this->_amiro_links_db_file);

        if(!(array_key_exists($this->_request_uri, $this->_links) && is_array($this->_links[$this->_request_uri]))) {
            if (isset($this->_links['__sape_new_url__']) && mb_strlen($this->_links['__sape_new_url__'])) {
                if (
                    isset($_SERVER['REMOTE_ADDR']) && in_array($_SERVER['REMOTE_ADDR'], $this->_links['__sape_ips__'])
                    ||
                    isset($_SERVER['HTTP_X_REAL_IP']) && in_array($_SERVER['HTTP_X_REAL_IP'], $this->_links['__sape_ips__'])
                    ||
                    isset($_SERVER['HTTP_REMOTE_ADDR']) && in_array($_SERVER['HTTP_REMOTE_ADDR'], $this->_links['__sape_ips__'])
                    ||
                    isset($_SERVER['HTTP_X_FORWARDED_FOR']) && in_array($_SERVER['HTTP_X_FORWARDED_FOR'], $this->_links['__sape_ips__'])
                    ||
                    $this->_force_show_code
                ) {
                    $GLOBALS["cms"]->Core->Cache->Disable();
                }
            }
        }

    }
}

?>